diff --git a/libgui/src/variable-editor.cc b/libgui/src/variable-editor.cc
--- a/libgui/src/variable-editor.cc
+++ b/libgui/src/variable-editor.cc
@@ -33,8 +33,10 @@ along with Octave; see the file COPYING.
 #include <QFileDialog>
 #include <QHeaderView>
 #include <QLabel>
+#include <QMdiArea>
 #include <QMenu>
 #include <QPalette>
+#include <QScreen>
 #include <QScrollBar>
 #include <QSignalMapper>
 #include <QStackedWidget>
@@ -50,216 +52,841 @@ along with Octave; see the file COPYING.
 #include "variable-editor.h"
 #include "variable-editor-model.h"
 
+// Code reuse functions
+
 static QString
 idx_to_expr (int32_t from, int32_t to)
 {
   return (from == to
-          ? QString ("%1").arg (from + 1)
-          : QString ("%1:%2").arg (from + 1).arg (to + 1));
+          ? QString ("%1").arg (from)
+          : QString ("%1:%2").arg (from).arg (to));
 }
 
-QTableView *
-var_editor_tab::get_edit_view (void) const
+QSignalMapper *
+make_plot_mapper (QMenu *menu)
 {
-  return (m_edit_view_idx == m_widget_stack->currentIndex ()
-          ? qobject_cast<QTableView *> (m_widget_stack->widget (m_edit_view_idx))
-          : nullptr);
+  QList<QString> list;
+  list << "plot" << "bar" << "stem" << "stairs" << "area" << "pie" << "hist";
+
+  QSignalMapper *plot_mapper = new QSignalMapper (menu);
+
+  for (int i = 0; i < list.size(); ++i)
+    {
+      plot_mapper->setMapping
+        (menu->addAction (list.at (i), plot_mapper, SLOT (map ())),
+         "figure (); " + list.at (i) + " (%1); title (\"%1\");");
+    }
+
+  return plot_mapper;
+}
+
+
+// Variable dock widget
+
+variable_dock_widget::variable_dock_widget (QWidget *p)
+  : label_dock_widget (p), m_initial_float (true)
+{
+  setFocusPolicy (Qt::StrongFocus);
+  // This controls whether the variable_dock_widgets are deleted
+  // or hidden when clicking the upper right X icon.  (Look for
+  // the checkmark of the variable_editor's context menu.)
+  // Could make this an option, or perhaps add a drop-down menu
+  // in place of X "close" icon.
+#if 0
+  setAttribute (Qt::WA_DeleteOnClose);
+#endif
+
+  connect (m_dock_action, SIGNAL (triggered (bool)),
+           this, SLOT (change_floating (bool)));
+  connect (m_close_action, SIGNAL (triggered (bool)),
+           this, SLOT (change_existence (bool)));
+  connect (this, SIGNAL (topLevelChanged(bool)),
+           this, SLOT (toplevel_change (bool)));
+}
+
+// slot for (un)dock action
+void
+variable_dock_widget::change_floating (bool)
+{
+  setFloating (! isFloating ());
+}
+
+// slot for hiding the widget
+void
+variable_dock_widget::change_existence (bool)
+{
+  close ();
+}
+
+void
+variable_dock_widget::toplevel_change (bool toplevel)
+{
+  if (toplevel)
+    {
+      m_dock_action->setIcon (QIcon (":/actions/icons/widget-dock.png"));
+      m_dock_action->setToolTip (tr ("Dock widget"));
+
+      // Make initial size expanded very large for "magnified" viewing
+      if (m_initial_float)
+        {
+          QScreen *pscreen = QGuiApplication::primaryScreen ();
+          QRect rect (0, 0, 0, 0);
+          rect = pscreen->availableGeometry ();
+          rect = QRect (rect.x () + 5, rect.y () + 5,
+                        rect.width () - 10, rect.height () - 10);
+          setGeometry (rect);
+          m_initial_float = false;
+        }
+
+      setFocus (Qt::OtherFocusReason);
+      activateWindow();
+    }
+  else
+    {
+      m_dock_action->setIcon (QIcon (":/actions/icons/widget-undock.png"));
+      m_dock_action->setToolTip (tr ("Undock widget"));
+
+      setFocus (Qt::OtherFocusReason);
+    }
+}
+
+void
+variable_dock_widget::closeEvent (QCloseEvent *e)
+{
+  QDockWidget::closeEvent (e);
+}
+
+void
+variable_dock_widget::handle_focus_change (QWidget *old, QWidget *now)
+{
+  octave_unused_parameter (now);
+
+  // The is a proxied test
+  if (hasFocus ())
+    {
+      QLabel *label = titleBarWidget ()->findChild<QLabel *> ();
+      if (label != nullptr)
+        label->setStyleSheet ("QLabel {background: skyblue;}");
+
+      emit variable_focused_signal (objectName ());
+    }
+  else if (old == focusWidget())
+    {
+      QLabel *label = titleBarWidget ()->findChild<QLabel *> ();
+      if (label != NULL)
+        label->setStyleSheet ("QLabel {background: transparent;}");
+    }
+}
+
+
+// Variable editor stack
+
+variable_editor_stack::variable_editor_stack (QWidget *p)
+  : QStackedWidget (p), m_edit_view (new variable_editor_view (this))
+{
+  setFocusPolicy (Qt::StrongFocus);
+
+  m_disp_view = make_disp_view (this);
+
+  addWidget (m_edit_view);
+  addWidget (m_disp_view);
 }
 
 QTextEdit *
-var_editor_tab::get_disp_view (void) const
+variable_editor_stack::make_disp_view (QWidget *parent)
 {
-  return (m_disp_view_idx == m_widget_stack->currentIndex ()
-          ? qobject_cast<QTextEdit *> (m_widget_stack->widget (m_disp_view_idx))
-          : nullptr);
+  QTextEdit *viewer = new QTextEdit (parent);
+
+  viewer->setLineWrapMode (QTextEdit::NoWrap);
+  viewer->setReadOnly (true);
+
+  return viewer;
 }
 
 void
-var_editor_tab::set_edit_view (QTableView *edit_view)
+variable_editor_stack::set_editable (bool editable)
 {
-  m_edit_view_idx = m_widget_stack->addWidget (edit_view);
+  // The QTableView is for editable data models
+  // and the QTextEdit is for non-editable models.
+
+  if (editable)
+    {
+      if (m_edit_view != nullptr)
+        {
+          setCurrentWidget (m_edit_view);
+          setFocusProxy (m_edit_view);
+          m_edit_view->setFocusPolicy (Qt::StrongFocus);
+        }
+
+      if (m_disp_view != nullptr)
+        m_disp_view->setFocusPolicy (Qt::NoFocus);
+    }
+  else
+    {
+      if (m_disp_view != nullptr)
+        {
+          setCurrentWidget (m_disp_view);
+          setFocusProxy (m_disp_view);
+
+          QAbstractTableModel *model = findChild<QAbstractTableModel *> ();
+          if (model != nullptr)
+            m_disp_view->setPlainText (model->data (QModelIndex ()).toString ());
+          else
+            m_disp_view->setPlainText ("");
+        }
+
+      if (m_edit_view != nullptr)
+        m_edit_view->setFocusPolicy (Qt::NoFocus);
+    }
 }
 
 void
-var_editor_tab::set_disp_view (QTextEdit *disp_view)
+variable_editor_stack::levelUp (void)
 {
-  m_disp_view_idx = m_widget_stack->addWidget (disp_view);
-}
+  if (! hasFocus ())
+    return;
 
-bool
-var_editor_tab::has_focus (void) const
-{
-  QTableView *edit_view = get_edit_view ();
-  QTextEdit *disp_view = get_disp_view ();
+  QString name = objectName ();
 
-  return ((disp_view && disp_view->hasFocus ())
-          || (edit_view && edit_view->hasFocus ()));
+  // FIXME: Is there a better way?
+
+  if (name.endsWith (')') || name.endsWith ('}'))
+    {
+      name.remove (QRegExp ("(\\(|\\{)[^({]*(\\)|\\})$"));
+      emit edit_variable_signal (name, octave_value ());
+    }
 }
 
 void
-var_editor_tab::keyPressEvent (QKeyEvent *event)
+variable_editor_stack::save (void)
 {
-  QTableView *edit_view = get_edit_view ();
+  if (! hasFocus ())
+    return;
 
-  if (edit_view)
+  QString name = objectName ();
+  QString file
+    = QFileDialog::getSaveFileName (this,
+                                    tr ("Save Variable %1 As").arg (name),
+                                     /* Should determine extension from save_default_options */
+                                    tr ("./%1.txt").arg (name),
+                                    0, 0,
+                                    QFileDialog::DontUseNativeDialog);
+
+  // FIXME: Type? binary, float-binary, ascii, text, hdf5, matlab format?
+  // FIXME: Call octave_value::save_* directly?
+
+  if (! file.isEmpty ())
+    emit command_signal (QString ("save (\"%1\", \"%2\");")
+                         .arg (file)
+                         .arg (name));
+}
+
+
+// Custom editable variable table view
+
+variable_editor_view::variable_editor_view (QWidget *p)
+  : QTableView (p), m_var_model (nullptr)
+{
+  setWordWrap (false);
+  setContextMenuPolicy (Qt::CustomContextMenu);
+  setSelectionMode (QAbstractItemView::ContiguousSelection);
+
+  horizontalHeader ()->setContextMenuPolicy (Qt::CustomContextMenu);
+  verticalHeader ()->setContextMenuPolicy (Qt::CustomContextMenu);
+
+  setHorizontalScrollMode (QAbstractItemView::ScrollPerPixel);
+  setVerticalScrollMode (QAbstractItemView::ScrollPerPixel);
+
+#if defined (HAVE_QT4)
+  verticalHeader ()->setResizeMode (QHeaderView::Interactive);
+#else
+  verticalHeader ()->setSectionResizeMode (QHeaderView::Interactive);
+#endif
+}
+
+void
+variable_editor_view::setModel (QAbstractItemModel *model)
+{
+  QTableView::setModel (model);
+
+#if defined (HAVE_QT4)
+  horizontalHeader ()->setResizeMode (QHeaderView::Interactive);
+#else
+  horizontalHeader ()->setSectionResizeMode (QHeaderView::Interactive);
+#endif
+
+  m_var_model = parent ()->findChild<variable_editor_model *> ();
+
+  if (m_var_model != nullptr && m_var_model->column_width () > 0)
     {
-      int key = event->key ();
+      // col_width is in characters.  The font should be a fixed-width
+      // font, so any character will do.  If not, you lose!
 
-      if (key == Qt::Key_Right || key == Qt::Key_Tab)
+      QFontMetrics fm (font ());
+      int w = m_var_model->column_width () * fm.width ('0');
+      horizontalHeader ()->setDefaultSectionSize (w);
+    }
+}
+
+QList<int>
+variable_editor_view::range_selected (void)
+{
+  QItemSelectionModel *sel = selectionModel ();
+
+  // Return early if nothing selected.
+  if (! sel->hasSelection ())
+    return QList<int> ();
+
+  QList<QModelIndex> indices = sel->selectedIndexes ();
+
+  // FIXME: Shouldn't this be keyed to octave_idx_type?
+
+  int32_t from_row = std::numeric_limits<int32_t>::max ();
+  int32_t to_row = 0;
+  int32_t from_col = std::numeric_limits<int32_t>::max ();
+  int32_t to_col = 0;
+
+  for (const auto& idx : indices)
+    {
+      from_row = std::min (from_row, idx.row ());
+      to_row = std::max (to_row, idx.row ());
+      from_col = std::min (from_col, idx.column ());
+      to_col = std::max (to_col, idx.column ());
+    }
+
+  QVector<int> vect;
+  vect << from_row + 1 << to_row + 1 << from_col + 1 << to_col + 1;
+  QList<int> range = QList<int>::fromVector(vect);
+
+  return range;
+}
+
+QString
+variable_editor_view::selected_to_octave (void)
+{
+  QList<int> range = range_selected ();
+  if (range.isEmpty ())
+    return objectName ();
+
+  QString rows = idx_to_expr (range.at (0), range.at (1));
+  QString cols = idx_to_expr (range.at (2), range.at (3));
+
+  // FIXME: Does cell need separate handling?  Maybe use '{.,.}'?
+
+  return QString ("%1(%2, %3)").arg (objectName ()).arg (rows).arg (cols);
+}
+
+void
+variable_editor_view::selected_command_requested (const QString& cmd)
+{
+  if (! hasFocus ())
+    return;
+
+  QString selarg = selected_to_octave ();
+  if (! selarg.isEmpty ())
+    emit command_signal (cmd.arg (selarg));
+}
+
+void
+variable_editor_view::add_edit_actions (QMenu *menu, const QString& qualifier_string)
+{
+  menu->addAction (resource_manager::icon ("edit-cut"),
+                   tr ("Cut") + qualifier_string,
+                   this, SLOT (cutClipboard ()));
+
+  menu->addAction (resource_manager::icon ("edit-copy"),
+                   tr ("Copy") + qualifier_string,
+                   this, SLOT (copyClipboard ()));
+
+  menu->addAction (resource_manager::icon ("edit-paste"),
+                   tr ("Paste"),
+                   this, SLOT (pasteClipboard ()));
+
+  // FIXME: Different icon for Paste Table?
+
+  menu->addAction (resource_manager::icon ("edit-paste"),
+                   tr ("Paste Table"),
+                   this, SLOT (pasteTableClipboard ()));
+
+  menu->addSeparator ();
+
+  menu->addAction (resource_manager::icon ("edit-delete"),
+                   tr ("Clear") + qualifier_string,
+                   this, SLOT (clearContent ()));
+
+  menu->addAction (resource_manager::icon ("edit-delete"),
+                   tr ("Delete") + qualifier_string,
+                   this, SLOT (delete_selected ()));
+
+  menu->addAction (resource_manager::icon ("document-new"),
+                   tr ("Variable from Selection"),
+                   this, SLOT (createVariable ()));
+}
+
+void
+variable_editor_view::createContextMenu (const QPoint& qpos)
+{
+  QModelIndex index = indexAt (qpos);
+
+  if (index.isValid ())
+    {
+      QMenu *menu = new QMenu (this);
+
+      add_edit_actions (menu, tr (""));
+
+      // FIXME: addAction for sort?
+      // FIXME: Add icon for transpose.
+
+      menu->addAction (tr ("Transpose"), this, SLOT (transposeContent ()));
+
+      QItemSelectionModel *sel = selectionModel ();
+
+      QList<QModelIndex> indices = sel->selectedIndexes ();
+
+      if (! indices.isEmpty ())
         {
-          QModelIndex idx = edit_view->currentIndex ();
+          menu->addSeparator ();
 
-          int curr_row = idx.row ();
-          int next_col = idx.column () + 1;
+          QSignalMapper *plot_mapper = make_plot_mapper (menu);
 
-          if (next_col == m_model->display_columns ())
+          connect (plot_mapper, SIGNAL (mapped (const QString&)),
+                   this, SLOT (selected_command_requested (const QString&)));
+        }
+
+      menu->exec (mapToGlobal (qpos));
+    }
+}
+
+void
+variable_editor_view::createColumnMenu (const QPoint& pt)
+{
+  int index = horizontalHeader ()->logicalIndexAt (pt);
+
+  if (index < 0 || index > model ()->columnCount ())
+    return;
+
+  QList<int> coords = range_selected ();
+
+  bool nothingSelected = coords.isEmpty ();
+
+  bool whole_columns_selected
+    =  (nothingSelected
+        ? false
+        : (coords[0] == 1 && coords[1] == model ()->rowCount ()));
+
+  bool current_column_selected
+    = nothingSelected ? false : (coords[2] <= index+1 && coords[3] > index);
+
+  int column_selection_count
+    = nothingSelected ? 0 : (coords[3] - coords[2] + 1);
+
+  if (! whole_columns_selected || ! current_column_selected)
+    {
+      selectColumn (index);
+      column_selection_count = 1;
+      current_column_selected = true;
+      whole_columns_selected = true;
+    }
+
+  QString column_string
+    = tr (column_selection_count > 1 ? " columns" : " column");
+
+  QMenu *menu = new QMenu (this);
+
+  add_edit_actions (menu, column_string);
+
+  menu->addSeparator ();
+
+  QSignalMapper *plot_mapper = make_plot_mapper (menu);
+
+  connect (plot_mapper, SIGNAL (mapped (const QString&)),
+           this, SLOT (selected_command_requested (const QString&)));
+
+  QPoint menupos = pt;
+  menupos.setY (horizontalHeader ()->height ());
+
+  menu->exec (mapToGlobal (menupos));
+}
+
+void
+variable_editor_view::createRowMenu (const QPoint& pt)
+{
+  int index = verticalHeader ()->logicalIndexAt (pt);
+
+  if (index < 0 || index > model ()->columnCount ())
+    return;
+
+  QList<int> coords = range_selected ();
+
+  bool nothingSelected = coords.isEmpty ();
+
+  bool whole_rows_selected
+    = (nothingSelected
+       ? false
+       : (coords[2] == 1 && coords[3] == model ()->columnCount ()));
+
+  bool current_row_selected
+    = (nothingSelected ? false : (coords[0] <= index+1 && coords[1] > index));
+
+  int rowselection_count = nothingSelected ? 0 : (coords[3] - coords[2] + 1);
+
+  if (! whole_rows_selected || ! current_row_selected)
+    {
+      selectRow (index);
+      rowselection_count = 1;
+      current_row_selected = true;
+      whole_rows_selected = true;
+    }
+
+  QString row_string = tr (rowselection_count > 1 ? " rows" : " row");
+
+  QMenu *menu = new QMenu (this);
+
+  add_edit_actions (menu, row_string);
+
+  menu->addSeparator ();
+
+  QSignalMapper *plot_mapper = make_plot_mapper (menu);
+
+  connect (plot_mapper, SIGNAL (mapped (const QString&)),
+           this, SLOT (selected_command_requested (const QString&)));
+
+  QPoint menupos = pt;
+  menupos.setX (verticalHeader ()->width ());
+
+  // FIXME: What was the intent here?
+  // setY (verticalHeader ()->sectionPosition (index+1) +
+  //       verticalHeader ()->sectionSize (index));
+
+  menu->exec (mapToGlobal (menupos));
+}
+
+void
+variable_editor_view::createVariable (void)
+{
+  // FIXME: Create unnamed1..n if exist ('unnamed', 'var') is true.
+
+  selected_command_requested ("unnamed = %1");
+}
+
+void
+variable_editor_view::transposeContent (void)
+{
+  if (! hasFocus ())
+    return;
+
+  emit command_signal (QString ("%1 = %1';").arg (objectName ()));
+}
+
+void
+variable_editor_view::delete_selected (void)
+{
+  if (! hasFocus ())
+    return;
+
+  QAbstractItemModel *mod = model ();
+  QList<int> coords = range_selected ();
+
+  if (coords.isEmpty ())
+    return;
+
+  bool whole_columns_selected
+    = coords[0] == 1 && coords[1] == mod->rowCount ();
+
+  bool whole_rows_selected
+    = coords[2] == 1 && coords[3] == mod->columnCount ();
+
+  // Must be deleting whole columns or whole rows, and not the whole thing.
+
+  if (whole_columns_selected == whole_rows_selected)
+    return;
+
+  if (whole_rows_selected)
+    mod->removeRows (coords[0], coords[1] - coords[0]);
+
+  if (whole_columns_selected)
+    mod->removeColumns (coords[2], coords[3] - coords[2]);
+}
+
+void
+variable_editor_view::clearContent (void)
+{
+  if (! hasFocus ())
+    return;
+
+  if (m_var_model == nullptr)
+    return;
+
+  QItemSelectionModel *sel = selectionModel ();
+  QList<QModelIndex> indices = sel->selectedIndexes ();
+
+  // FIXME: Use [] for empty cells?
+
+  for (const auto& idx : indices)
+    m_var_model->clear_content (idx);
+}
+
+void
+variable_editor_view::cutClipboard (void)
+{
+  copyClipboard ();
+
+  clearContent ();
+}
+
+void
+variable_editor_view::copyClipboard (void)
+{
+  if (! hasFocus ())
+    return;
+
+  QItemSelectionModel *sel = selectionModel ();
+  QList<QModelIndex> indices = sel->selectedIndexes ();
+  qSort (indices);
+
+  if (indices.isEmpty ())
+    return;
+
+  // Convert selected items into TSV format and copy that.
+  // Spreadsheet tools should understand that.
+
+  QAbstractItemModel *mod = model ();
+  QModelIndex previous = indices.first ();
+  QString copy = mod->data (previous).toString ();
+  indices.removeFirst ();
+  foreach (QModelIndex idx, indices)
+    {
+      copy.push_back (previous.row () != idx.row () ? '\n' : '\t');
+      copy.append (mod->data (idx).toString ());
+      previous = idx;
+    }
+
+  QClipboard *clipboard = QApplication::clipboard ();
+  clipboard->setText (copy);
+}
+
+void
+variable_editor_view::pasteClipboard (void)
+{
+  if (! hasFocus ())
+    return;
+
+  QAbstractItemModel *mod = model ();
+  QItemSelectionModel *sel = selectionModel ();
+  QList<QModelIndex> indices = sel->selectedIndexes ();
+
+  QClipboard *clipboard = QApplication::clipboard ();
+  QString text = clipboard->text ();
+
+  if (indices.isEmpty ())
+    {
+      if (size () == QSize (1,1))
+        mod->setData (mod->index (0,0), text.toDouble ());
+      else if (size () == QSize (0,0))
+        {
+          mod->insertColumn (0);
+          mod->insertRow (0);
+          mod->setData (mod->index (0,0), text.toDouble ());
+        }
+    }
+  else
+    {
+      QStringList cells = text.split(QRegExp("\n|\r\n|\r"));
+      int clen = cells.size ();
+      for (int i = 0; i < indices.size (); i++)
+        mod->setData (indices[i], cells.at (i % clen).toDouble ());
+    }
+}
+
+void variable_editor_view::pasteTableClipboard (void)
+{
+  if (! hasFocus ())
+    return;
+
+  QAbstractItemModel *mod = model ();
+  QItemSelectionModel *sel = selectionModel ();
+  QList<QModelIndex> indices = sel->selectedIndexes ();
+
+  QClipboard *clipboard = QApplication::clipboard ();
+  QString text = clipboard->text ();
+
+  QPoint start, end;
+
+  QPoint tabsize = QPoint (mod->rowCount (), mod->columnCount ());
+
+  if (indices.isEmpty ())
+    {
+      start = QPoint (0,0);
+      end = tabsize;
+    }
+  else if (indices.size () == 1)
+    {
+      start = QPoint (indices[0].row (), indices[0].column ());
+      end = tabsize;
+    }
+  else
+    {
+      end = QPoint (0,0);
+      start = tabsize;
+
+      for (int i = 0; i < indices.size (); i++)
+        {
+          if (indices[i].column () < start.y ())
+            start.setY (indices[i].column ());
+
+          if (indices[i].column () > end.y ())
+            end.setY (indices[i].column ());
+
+          if (indices[i].row () < start.x ())
+            start.setX (indices[i].column ());
+
+          if (indices[i].row () > end.x ())
+            end.setX (indices[i].column ());
+        }
+    }
+
+  int rownum = 0;
+  int colnum = 0;
+
+  QStringList rows = text.split ('\n');
+  for (const auto& row : rows)
+    {
+      if (rownum > end.x () - start.x ())
+        continue;
+
+      QStringList cols = row.split ('\t');
+      if (cols.isEmpty ())
+        continue;
+
+      for (const auto& col : cols)
+        {
+          if (col.isEmpty ())
+            continue;
+          if (colnum > end.y () - start.y () )
+            continue;
+
+          mod->setData (mod->index (rownum + start.x (),
+                                    colnum + start.y ()),
+                        QVariant (col));
+
+          colnum++;
+        }
+
+      colnum = 0;
+      rownum++;
+    }
+}
+
+void
+variable_editor_view::handle_horizontal_scroll_action (int action)
+{
+  if (action == QAbstractSlider::SliderSingleStepAdd
+      || action == QAbstractSlider::SliderPageStepAdd
+      || action == QAbstractSlider::SliderToMaximum
+      || action == QAbstractSlider::SliderMove)
+    {
+      if (m_var_model != nullptr)
+        {
+          QScrollBar *sb = horizontalScrollBar ();
+
+          if (sb && sb->value () == sb->maximum ())
             {
-              m_model->maybe_resize_columns (next_col + 16);
+              int new_cols = m_var_model->display_columns () + 16;
 
-              edit_view->setCurrentIndex (m_model->index (curr_row, next_col));
-            }
-        }
-      else if (key == Qt::Key_Down || key == Qt::Key_PageDown)
-        {
-          QModelIndex idx = edit_view->currentIndex ();
-
-          int next_row = idx.row () + 1;
-          int curr_col = idx.column ();
-
-          if (next_row == m_model->display_rows ())
-            {
-              m_model->maybe_resize_rows (next_row + 16);
-
-              edit_view->setCurrentIndex (m_model->index (next_row, curr_col));
+              m_var_model->maybe_resize_columns (new_cols);
             }
         }
     }
 }
 
 void
-var_editor_tab::set_editable (bool editable)
-{
-  int idx = (editable ? m_edit_view_idx : m_disp_view_idx);
-
-  m_widget_stack->setCurrentIndex (idx);
-
-  if (! editable)
-    {
-      QTextEdit *viewer = get_disp_view ();
-
-      QVariant v_data = m_model->data ();
-
-      QString str = v_data.toString ();
-
-      viewer->setPlainText (str);
-    }
-}
-
-void
-var_editor_tab::handle_horizontal_scroll_action (int action)
+variable_editor_view::handle_vertical_scroll_action (int action)
 {
   if (action == QAbstractSlider::SliderSingleStepAdd
       || action == QAbstractSlider::SliderPageStepAdd
       || action == QAbstractSlider::SliderToMaximum
       || action == QAbstractSlider::SliderMove)
     {
-      QTableView *edit_view = get_edit_view ();
-
-      if (edit_view)
+      if (m_var_model != nullptr)
         {
-          QScrollBar *sb = edit_view->horizontalScrollBar ();
+          QScrollBar *sb = verticalScrollBar ();
 
           if (sb && sb->value () == sb->maximum ())
             {
-              int new_cols = m_model->display_columns () + 16;
+              int new_rows = m_var_model->display_rows () + 16;
 
-              m_model->maybe_resize_columns (new_cols);
+              m_var_model->maybe_resize_rows (new_rows);
             }
         }
     }
 }
 
-void
-var_editor_tab::handle_vertical_scroll_action (int action)
+
+// Gadgets for focus restoration
+
+HoverToolButton::HoverToolButton (QWidget *parent)
+  : QToolButton (parent)
 {
-  if (action == QAbstractSlider::SliderSingleStepAdd
-      || action == QAbstractSlider::SliderPageStepAdd
-      || action == QAbstractSlider::SliderToMaximum
-      || action == QAbstractSlider::SliderMove)
-    {
-      QTableView *edit_view = get_edit_view ();
-
-      if (edit_view)
-        {
-          QScrollBar *sb = edit_view->verticalScrollBar ();
-
-          if (sb && sb->value () == sb->maximum ())
-            {
-              int new_rows = m_model->display_rows () + 16;
-
-              m_model->maybe_resize_rows (new_rows);
-            }
-        }
-    }
+  installEventFilter (this);
 }
 
-// Functions for reimplemented tab widget.
+bool HoverToolButton::eventFilter (QObject *obj, QEvent *ev)
+{
+  if (ev->type () == QEvent::HoverEnter)
+    emit hovered_signal ();
+  else if (ev->type () == QEvent::MouseButtonPress ||
+           ev->type () == QEvent::MouseButtonPress)
+    emit popup_shown_signal ();
 
-var_editor_tab_widget::var_editor_tab_widget (QWidget *p)
-  : QTabWidget (p)
-{
-  tab_bar *bar = new tab_bar (this);
-
-  connect (bar, SIGNAL (close_current_tab_signal (bool)),
-           p->parent (), SLOT (request_close_tab (bool)));
-
-  this->setTabBar (bar);
-
-  setTabsClosable (true);
-  setMovable (true);
+  return QToolButton::eventFilter (obj, ev);
 }
 
-tab_bar *
-var_editor_tab_widget::get_tab_bar (void) const
+ReturnFocusToolButton::ReturnFocusToolButton (QWidget *parent)
+  : HoverToolButton (parent)
 {
-  return qobject_cast<tab_bar *> (tabBar ());
+  installEventFilter (this);
 }
 
-bool
-var_editor_tab_widget::current_tab_has_focus (void) const
+bool ReturnFocusToolButton::eventFilter (QObject *obj, QEvent *ev)
 {
-  var_editor_tab *tab
-    = qobject_cast<var_editor_tab *> (widget (currentIndex ()));
 
-  return tab->has_focus ();
+  if (ev->type () == QEvent::MouseButtonRelease && isDown ())
+    {
+      emit about_to_activate ();
+
+      setDown (false);
+      QAction *action = defaultAction ();
+      if (action != nullptr)
+        action->activate (QAction::Trigger);
+
+      return true;
+    }
+
+  return HoverToolButton::eventFilter (obj, ev);
 }
 
-QTableView *
-var_editor_tab_widget::get_edit_view (void) const
+ReturnFocusMenu::ReturnFocusMenu (QWidget *parent)
+  : QMenu (parent)
 {
-  var_editor_tab *tab
-    = qobject_cast<var_editor_tab *> (widget (currentIndex ()));
-
-  return tab->get_edit_view ();
+  installEventFilter (this);
 }
 
-QTextEdit *
-var_editor_tab_widget::get_disp_view (void) const
+bool ReturnFocusMenu::eventFilter (QObject *obj, QEvent *ev)
 {
-  var_editor_tab *tab
-    = qobject_cast<var_editor_tab *> (widget (currentIndex ()));
+  if (ev->type () == QEvent::MouseButtonRelease && underMouse ())
+    {
+      emit about_to_activate ();
+    }
 
-  return tab->get_disp_view ();
+  return QMenu::eventFilter (obj, ev);
 }
 
 // Variable editor.
 
 variable_editor::variable_editor (QWidget *p)
   : octave_dock_widget (p),
-    m_container (new QWidget (this)),
-    m_tool_bar (new QToolBar ("", m_container)),
-    m_tab_widget (new var_editor_tab_widget (m_container)),
-    m_tab_bar (m_tab_widget->get_tab_bar ()),
+    m_main (new QMainWindow ()),
+    m_tool_bar (new QToolBar (m_main)),
     m_default_width (30),
     m_default_height (100),
     m_add_font_height (0),
@@ -269,63 +896,44 @@ variable_editor::variable_editor (QWidge
     m_font (),
     m_sel_font (),
     m_table_colors (),
-    m_close_action (nullptr),
-    m_close_others_action (nullptr),
-    m_close_all_action (nullptr)
+    m_current_focus_vname (""),
+    m_hovered_focus_vname ("")
 {
   setObjectName ("variable_editor");
   set_title (tr ("Variable Editor"));
   setStatusTip (tr ("Edit variables."));
   setWindowIcon (QIcon (":/actions/icons/logo.png"));
+  setFocusPolicy (Qt::NoFocus);
+  setAttribute (Qt::WA_AlwaysShowToolTips);
+
+  // Tool Bar.
 
   construct_tool_bar ();
+  m_main->addToolBar (m_tool_bar);
+  m_main->setFocusPolicy (Qt::NoFocus);
+  setFocusPolicy (Qt::NoFocus);
 
   // Colors.
 
   for (int i = 0; i < resource_manager::varedit_color_chars ().length (); i++)
     m_table_colors.append (QColor (Qt::white));
 
-  // Tab Widget.
+  // Use an MDI area that is shrunk to nothing as the central widget.
+  // Future feature might be to switch to MDI mode in which the dock
+  // area is shrunk to nothing and the widgets live in the MDI window.
 
-  connect (m_tab_widget, SIGNAL (tabCloseRequested (int)),
-           this, SLOT (closeTab (int)));
+  QMdiArea *central_mdiarea = new QMdiArea (m_main);
+  central_mdiarea->setMinimumSize (QSize (0, 0));
+  central_mdiarea->setMaximumSize (QSize (0, 0));
+  central_mdiarea->resize (QSize (0, 0));
+  m_main->setCentralWidget (central_mdiarea);
 
-  // Tab bar.
+  m_main->setParent (this);
+  m_main->setDockOptions (QMainWindow::AllowNestedDocks |
+                          QMainWindow::VerticalTabs);
+  setWidget (m_main);
 
-  m_close_action
-    = add_action (m_tab_bar->get_context_menu (),
-                  resource_manager::icon ("window-close",false),
-                  tr ("&Close"),
-                  SLOT (request_close_tab (bool)));
-
-  m_close_others_action
-    = add_action (m_tab_bar->get_context_menu (),
-                  resource_manager::icon ("window-close",false),
-                  tr ("Close &Other Tabs"),
-                  SLOT (request_close_other_tabs (bool)));
-
-  m_close_all_action
-    = add_action (m_tab_bar->get_context_menu (),
-                  resource_manager::icon ("window-close",false),
-                  tr ("Close &All Tabs"),
-                  SLOT (request_close_all_tabs (bool)));
-
-  enable_actions ();
-
-  // Layout the widgets vertically with the toolbar on top.
-
-  QVBoxLayout *vbox_layout = new QVBoxLayout ();
-
-  vbox_layout->setSpacing (0);
-  vbox_layout->addWidget (m_tool_bar);
-  vbox_layout->addWidget (m_tab_widget);
-  vbox_layout->setMargin (1);
-
-  m_container->setLayout (vbox_layout);
-
-  setWidget (m_container);
-
-  connect (this, SIGNAL (command_requested (const QString&)),
+  connect (this, SIGNAL (command_signal (const QString&)),
            p, SLOT (execute_command_in_terminal (const QString&)));
 }
 
@@ -351,48 +959,6 @@ variable_editor::add_action (QMenu *menu
   return a;
 }
 
-// Slot for the close tab action.
-
-void
-variable_editor::request_close_tab (bool)
-{
-  closeTab (m_tab_bar->currentIndex ());
-}
-
-// Slot for the close other tabs action.
-
-void
-variable_editor::request_close_other_tabs (bool)
-{
-  int current = m_tab_bar->currentIndex ();
-
-  for (int index = m_tab_bar->count ()-1; index >= 0; index--)
-    {
-      if (current != index)
-        closeTab (index);
-    }
-}
-
-// Slot for closing all tabs.
-
-void
-variable_editor::request_close_all_tabs (bool)
-{
-  for (int index = m_tab_bar->count ()-1; index >= 0; index--)
-    closeTab (index);
-}
-
-void
-variable_editor::enable_actions (void)
-{
-  const int count = m_tab_widget->count ();
-
-  m_tool_bar->setEnabled (count > 0);
-  m_close_action->setEnabled (count > 0);
-  m_close_all_action->setEnabled (count > 0);
-  m_close_others_action->setEnabled (count > 1);
-}
-
 void
 variable_editor::edit_variable (const QString& name, const octave_value& val)
 {
